<template>
	<v-container class="field-show flex-grow-1" :class="{ 'pb-0 px-0': $vuetify.breakpoint.smAndDown }">
		<v-dialog :value="hasError" max-width="50em" persistent>
			<v-card>
				<v-toolbar color="grey lighten-2" flat>
					<v-toolbar-title>Error</v-toolbar-title>
				</v-toolbar>
				<v-divider />
				<v-card-text>
					<div class="d-flex justify-center align-center mt-4 mx-2">
						<v-icon color="error">mdi-alert-circle</v-icon>
						<v-divider vertical class="mx-2"></v-divider>
						<p class="mt-0 mb-0">An error occurred while attempting to create the field. Please try again.</p>
					</div>
				</v-card-text>
				<v-divider />
				<v-card-actions class="d-flex flex-wrap justify-end">
					<v-btn text rounded @click="clearError" :disabled="isLoading">Ok</v-btn>
				</v-card-actions>
			</v-card>
		</v-dialog>

		<v-stepper v-model="step">
			<v-stepper-header>
				<v-stepper-step :step="FieldCreateStepEnum.AREA" :complete="step > FieldCreateStepEnum.AREA">
					Draw Field Boundary
				</v-stepper-step>
				<v-divider />
				<v-stepper-step :step="FieldCreateStepEnum.FORM" :complete="step > FieldCreateStepEnum.FORM">
					Enter Field Details
				</v-stepper-step>
				<v-divider />
				<v-stepper-step :step="FieldCreateStepEnum.REVIEW">Review</v-stepper-step>
			</v-stepper-header>

			<v-stepper-items>
				<v-stepper-content class="pa-0 pt-1 sm:pa-6" :step="FieldCreateStepEnum.AREA">
					<area-draw-editor
						v-if="step === FieldCreateStepEnum.AREA"
						v-model="areaDraws"
						cancel-button="Cancel"
						@cancel="navigateToFieldsView"
						@submit="handleArea"
					/>
				</v-stepper-content>
				<v-stepper-content class="pa-0 pt-1 sm:pa-6" :step="FieldCreateStepEnum.FORM">
					<field-create-form @submit="handleFieldForm" cancel-button="Back" @cancel="step = FieldCreateStepEnum.AREA" />
				</v-stepper-content>
				<v-stepper-content class="pa-0 pt-1 sm:pa-6" :step="FieldCreateStepEnum.REVIEW">
					<area-draw-review
						v-if="step === FieldCreateStepEnum.REVIEW"
						:area="area"
						:loading="isLoading"
						@back="step = FieldCreateStepEnum.FORM"
						@submit="handleSubmit"
					>
						<v-card flat>
							<v-card-title>
								{{ field.name }}
							</v-card-title>
							<v-card-text>
								<span class="text-h6"> Details </span>
								<div>
									<div class="font-weight-bold">Group</div>
									<ul class="ml-2">
										<li>{{ `(${field.meta.groupId})` }}</li>
									</ul>
								</div>
								<div v-if="isValidObject(field.address)">
									<div class="font-weight-bold">Address</div>
									<p class="ml-2">
										<field-address :address="field.address" :area="area" />
									</p>
								</div>
								<div v-if="validContactPoints.length > 0">
									<div class="font-weight-bold">Contact</div>
									<ul class="ml-2">
										<field-contact v-for="(contact, index) in validContactPoints" :key="index" :contact="contact" />
									</ul>
								</div>
							</v-card-text>
						</v-card>
					</area-draw-review>
				</v-stepper-content>
			</v-stepper-items>
		</v-stepper>
	</v-container>
</template>

<script lang="ts">
import { computed, defineComponent, ref } from '@vue/composition-api';
import { Feature, MultiPolygon, Polygon } from 'geojson';
import { useCreateField } from '@/store/modules/fields';
import { Area, ContactPoint, Field } from '@/store/types';
import AreaDrawEditor from './Area/AreaDrawEditor.vue';
import AreaDrawReview from './Area/AreaDrawReview.vue';
import FieldAddress from './FieldAddress/FieldAddress.vue';
import FieldContact from './FieldContact/FieldContact.vue';
import FieldCreateForm from './FieldCreate/FieldCreateForm.vue';

enum FieldCreateStepEnum {
	AREA = 1,
	FORM,
	REVIEW,
}

export default defineComponent({
	components: { FieldCreateForm, AreaDrawEditor, AreaDrawReview, FieldAddress, FieldContact },
	setup(props, { root }) {
		const step = ref<number>(FieldCreateStepEnum.AREA);
		const field = ref<Partial<Field>>({});
		const area = ref<Feature<MultiPolygon>>();
		const areaDraws = ref<Feature<Polygon>[]>([]);
		const { createField, clearError, isLoading, hasError } = useCreateField(root.$store);

		const isValidObject = (obj: { [key: string]: string } = {}): boolean => Object.values(obj).join().length > 0;

		const validContactPoints = computed<ContactPoint[]>(() => field.value.contactPoints?.filter(isValidObject) ?? []);

		const handleFieldForm = (value: Partial<Field>) => {
			field.value = value;
			step.value = FieldCreateStepEnum.REVIEW;
		};

		const handleArea = (finalizedArea: Feature<MultiPolygon>) => {
			area.value = finalizedArea;
			step.value = FieldCreateStepEnum.FORM;
		};

		const handleSubmit = () => {
			clearError();

			createField({
				groupId: field.value.meta?.groupId ?? '',
				name: field.value.name,
				producerName: field.value.producerName,
				address: field.value.address,
				contactPoints: validContactPoints.value,
				areas: area.value
					? [
							{
								...area.value,
								properties: { ...area.value.properties, drawn: true },
							} as Omit<Area, 'id'>,
					  ]
					: [],
			});
		};

		const navigateToFieldsView = () => root.$router.push('/fields');

		return {
			FieldCreateStepEnum,
			step,
			field,
			area,
			areaDraws,
			validContactPoints,
			isLoading,
			hasError,
			clearError,
			isValidObject,
			handleFieldForm,
			handleArea,
			handleSubmit,
			navigateToFieldsView,
		};
	},
});
</script>
